.\"	$NetBSD: mount_portal.8,v 1.20 2005/01/31 05:19:19 erh Exp $
.\"
.\" Copyright (c) 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software donated to Berkeley by
.\" Jan-Simon Pendry.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)mount_portal.8	8.3 (Berkeley) 3/27/94
.\"
.Dd December 5, 2009
.Dt MOUNT_PORTAL 8
.Os
.Sh NAME
.Nm mount_portal
.Nd mount the portal daemon
.Sh SYNOPSIS
.Nm
.Op Fl o Ar options
.Ar /etc/portal.conf
.Ar mount_point
.Sh DESCRIPTION
The
.Nm
command attaches an instance of the portal daemon
to the global filesystem namespace.
The conventional mount point is
.Pa /p .
The directory specified by
.Ar mount_point
is converted to an absolute path before use.
This command is normally executed by
.Xr mount 8
at boot time.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl o
Options are specified with a
.Fl o
flag followed by a comma separated string of options.
See the
.Xr mount 8
man page for possible options and their meanings.
.El
.Pp
The portal daemon provides an
.Em open
service.
Objects opened under the portal mount point are
dynamically created by the portal daemon according
to rules specified in the named configuration file.
Using this mechanism allows descriptors such as sockets
to be made available in the filesystem namespace.
.Pp
The portal daemon works by being passed the full pathname
of the object being opened.
The daemon creates an appropriate descriptor according
to the rules in the configuration file, and then passes the descriptor back
to the calling process as the result of the open system call.
.Sh NAMESPACE
By convention, the portal daemon divides the namespace into sub-namespaces,
each of which handles objects of a particular type.
.Pp
Currently, four sub-namespaces are implemented:
.Pa tcp ,
.Pa fs ,
.Pa rfilter
and
.Pa wfilter .
The
.Pa tcp
namespace takes a hostname and a port (slash separated) and
creates an open TCP/IP connection.
The
.Pa fs
namespace opens the named file, starting back at the root directory.
This can be used to provide a controlled escape path from
a chrooted environment.
.Pp
The
.Pa rfilter
and
.Pa wfilter
namespaces open a pipe to a process, typically a data-filter such
as compression or decompression programs.
The
.Pa rfilter
namespace opens a read-only pipe, while the
.Pa wfilter
namespace opens a write-only pipe.
See the
.Sx EXAMPLES
section below for more examples.
.Sh CONFIGURATION FILE
The configuration file contains a list of rules.
Each rule takes one line and consists of two or more
whitespace separated fields.
A hash
.Pq Dq #
character causes the remainder of a line to be ignored.
Blank lines are ignored.
.Pp
The first field is a pathname prefix to match
against the requested pathname.
If a match is found, the second field
tells the daemon what type of object to create.
Subsequent fields are passed to the creation function.
.Pp
The
.Pa rfilter
and
.Pa wfilter
namespaces have additional meanings for the remaining fields.
The third field specifies a prefix that is to be stripped off of
the passed name before passing it on to the pipe program.
If the prefix does not match, no stripping is performed.
The fourth argument specifies the program to use for the pipe.
Any remaining fields are passed to the pipe program.
If the string
.Dq Li "%s"
exists within these remaining fields, it will be replaced by the
path after stripping is performed.
If there is no field after the program name,
.Dq Li "%s"
will be assumed, to maintain similarity with the
.Pa tcp
and
.Pa fs
namespaces.
.Sh FILES
.Bl -tag -width /p/* -compact
.It Pa /p/*
.El
.Sh EXAMPLES
A tutorial and several examples are provided in
.Pa /usr/share/examples/mount_portal .
The following is an example configuration file.
.Pp
.Bd -literal
# @(#)portal.conf	5.1 (Berkeley) 7/13/92
tcp/		tcp tcp/
fs/		file fs/
echo/		rfilter	echo/	echo %s
echo_nostrip/	rfilter	nostrip	echo %s
echo_noslash    rfilter echo_noslash    echo %s
gzcat/		rfilter gzcat/ gzcat %s
gzip/		wfilter	gzip/	gzip \*[Gt] %s
gzip9/		wfilter	gzip9/	gzip -9 \*[Gt] %s
ftp/		rfilter	ftp/	ftp -Vo - %s
ftp://		rfilter	nostrip	ftp -Vo - %s
http://		rfilter	nostrip	ftp -Vo - %s
bzcat/		rfilter	bzcat/	bzcat %s
nroff/		rfilter	nroff/	nroff -man %s
.Ed
.Pp
As is true with many other filesystems, a weird sense of humor is handy.
.Pp
Notice that after the keynames, like nroff/ and bzcat/, we
typically use another slash.
In reality, the
.Nm
process changes directory to
.Pa / ,
which makes the subsequent slash unnecessary.
However, the extra slash provides a visual hint
that we are not operating on an ordinary file.
An alternative would be to change the configuration
file to something like:
.Bd -literal
nroff%	rfilter	nroff%	nroff -man
.Ed
.Pp
One might then use
.Bd -literal
less /p/nroff%/usr/share/man/man8/mount_portal.8
.Ed
.Sh SEE ALSO
.Xr mount 2 ,
.Xr unmount 2 ,
.Xr fstab 5 ,
.Xr mount 8
.Sh HISTORY
The
.Nm
utility first appeared in
.Bx 4.4 .
The
.Pa rfilter
and
.Pa wfilter
capabilities first appeared in
.Nx 1.5 .
The portal kernel driver was removed and
.Nm
was converted to use
.Xr puffs 3
in
.Nx 6.0 .
.Sh BUGS
This filesystem may not be NFS-exported.
